# include "stdio.h"
#if defined(__cplusplus)
   extern "C" {
#endif
#if (defined(__cplusplus) || defined(__STDC__))
     extern int yyreject();
     extern int yywrap();
     extern int yylook();
     extern int yyback(int *, int);
     extern int yyinput();
     extern void yyoutput(int);
     extern void yyunput(int);
     extern int yylex();
     extern int yyless(int);
#ifdef LEXDEBUG
     extern void allprint();
     extern void sprint();
#endif
#if defined(__cplusplus)
   }
#endif
#endif	/* __cplusplus or __STDC__ */
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX 200
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng;
int yylenguc;
extern unsigned char yytextarr[];
# ifdef YYCHAR_ARRAY
extern char yytext[];
# else
extern unsigned char yytext[];
# endif
int yyposix_point=0;
int yynls16=0;
int yynls_wchar=0;
char *yylocale = "C C C C C C";
int yymorfg;
extern unsigned char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	int yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
/*
 * Copyright (c) 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996, 1997
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code distributions
 * retain the above copyright notice and this paragraph in its entirety, (2)
 * distributions including binary code include the above copyright notice and
 * this paragraph in its entirety in the documentation or other materials
 * provided with the distribution, and (3) all advertising materials mentioning
 * features or use of this software display the following acknowledgement:
 * ``This product includes software developed by the University of California,
 * Lawrence Berkeley Laboratory and its contributors.'' Neither the name of
 * the University nor the names of its contributors may be used to endorse
 * or promote products derived from this software without specific prior
 * written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef lint
static const char rcsid[] =
    "@(#) $Header: scanner.l,v 1.56 97/07/21 13:31:50 leres Exp $ (LBL)";
#endif

#include <sys/types.h>
#include <sys/time.h>

#include <ctype.h>
#include <unistd.h>

#include "pcap-int.h"

#include "gencode.h"
#include <pcap-namedb.h>
#include "tokdefs.h"

#include "gnuc.h"
#ifdef HAVE_OS_PROTO_H
#include "os-proto.h"
#endif

static int stoi(char *);
static inline int xdtoi(int);

#ifdef FLEX_SCANNER
#define YY_NO_UNPUT
#undef YY_INPUT
#define YY_INPUT(buf, result, max)\
 {\
	char *src = in_buffer;\
	int i;\
\
	if (*src == 0)\
		result = YY_NULL;\
	else {\
		for (i = 0; *src && i < max; ++i)\
			buf[i] = *src++;\
		in_buffer += i;\
		result = i;\
	}\
 }
#else
#undef getc
#define getc(fp)  (*in_buffer == 0 ? EOF : *in_buffer++)
#endif

#define yylval pcap_lval
extern YYSTYPE yylval;

static char *in_buffer;

# define YYNEWLINE 10
yylex(){
   int nstr; extern int yyprevious;
   while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
   if(yywrap()) return(0); break;
case 1:
	return DST;
break;
case 2:
	return SRC;
break;
case 3:
 return LINK;
break;
case 4:
	return LINK;
break;
case 5:
	return ARP;
break;
case 6:
	return RARP;
break;
case 7:
	return IP;
break;
case 8:
	return TCP;
break;
case 9:
	return UDP;
break;
case 10:
	return ICMP;
break;
case 11:
	return IGMP;
break;
case 12:
	return IGRP;
break;
case 13:
	return ATALK;
break;
case 14:
	return DECNET;
break;
case 15:
	return LAT;
break;
case 16:
	return SCA;
break;
case 17:
	return MOPRC;
break;
case 18:
	return MOPDL;
break;
case 19:
	return HOST;
break;
case 20:
	return NET;
break;
case 21:
	return MASK;
break;
case 22:
	return PORT;
break;
case 23:
	return PROTO;
break;
case 24:
	return GATEWAY;
break;
case 25:
	return LESS;
break;
case 26:
	return GREATER;
break;
case 27:
	return BYTE;
break;
case 28:
return TK_BROADCAST;
break;
case 29:
return TK_MULTICAST;
break;
case 30:
return AND;
break;
case 31:
	return OR;
break;
case 32:
	return '!';
break;
case 33:
return LEN;
break;
case 34:
	return INBOUND;
break;
case 35:
return OUTBOUND;
break;
case 36:
		;
break;
case 37:
return yytext[0];
break;
case 38:
		return GEQ;
break;
case 39:
		return LEQ;
break;
case 40:
		return NEQ;
break;
case 41:
		return '=';
break;
case 42:
		return LSH;
break;
case 43:
		return RSH;
break;
case 44:
		{ yylval.i = stoi((char *)yytext); return NUM; }
break;
case 45:
{
			yylval.s = sdup((char *)yytext); return HID; }
break;
case 46:
{ yylval.e = pcap_ether_aton((char *)yytext);
			  return EID; }
break;
case 47:
	{ bpf_error("bogus ethernet address %s", yytext); }
break;
case 48:
{
			 yylval.s = sdup((char *)yytext); return ID; }
break;
case 49:
{ yylval.s = sdup((char *)yytext + 1); return ID; }
break;
case 50:
{
			bpf_error("illegal token: %s\n", yytext); }
break;
case 51:
		{ bpf_error("illegal char '%c'", *yytext); }
break;
case -1:
break;
default:
   fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */

#ifndef __cplusplus
static void __yy__unused() { main(); }
#endif
void
lex_init(buf)
	char *buf;
{
	in_buffer = buf;
}

/*
 * Also define a yywrap.  Note that if we're using flex, it will
 * define a macro to map this identifier to pcap_wrap.
 */
int
yywrap()
{
	return 1;
}

/* Hex digit to integer. */
static inline int
xdtoi(c)
	register int c;
{
	if (isdigit(c))
		return c - '0';
	else if (islower(c))
		return c - 'a' + 10;
	else
		return c - 'A' + 10;
}

/*
 * Convert string to integer.  Just like atoi(), but checks for
 * preceding 0x or 0 and uses hex or octal instead of decimal.
 */
static int
stoi(s)
	char *s;
{
	int base = 10;
	int n = 0;

	if (*s == '0') {
		if (s[1] == 'x' || s[1] == 'X') {
			s += 2;
			base = 16;
		}
		else {
			base = 8;
			s += 1;
		}
	}
	while (*s)
		n = n * base + xdtoi(*s++);

	return n;
}

int yyvstop[] = {
0,

51,
0,

36,
51,
0,

36,
0,

37,
51,
0,

37,
51,
0,

37,
51,
0,

37,
51,
0,

51,
0,

44,
51,
0,

44,
51,
0,

37,
51,
0,

37,
51,
0,

37,
51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

37,
51,
0,

50,
0,

40,
0,

30,
0,

48,
0,

44,
48,
0,

48,
0,

48,
0,

48,
0,

42,
0,

39,
0,

41,
0,

38,
0,

43,
0,

49,
0,

49,
0,

49,
50,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

7,
48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

31,
48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

31,
0,

45,
48,
0,

45,
48,
0,

44,
48,
0,

44,
48,
0,

30,
48,
0,

5,
48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

1,
48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

15,
48,
0,

33,
48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

20,
48,
0,

32,
48,
0,

48,
0,

48,
0,

3,
48,
0,

48,
0,

48,
0,

16,
48,
0,

48,
0,

2,
48,
0,

8,
48,
0,

9,
48,
0,

48,
0,

48,
0,

47,
0,

48,
0,

48,
0,

27,
48,
0,

48,
0,

48,
0,

4,
48,
0,

48,
0,

48,
0,

19,
48,
0,

10,
48,
0,

11,
48,
0,

12,
48,
0,

48,
0,

48,
0,

25,
48,
0,

21,
48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

22,
48,
0,

48,
0,

6,
48,
0,

45,
48,
0,

45,
48,
0,

45,
48,
0,

47,
0,

13,
48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

48,
0,

18,
48,
0,

17,
48,
0,

48,
0,

48,
0,

23,
48,
0,

48,
0,

48,
0,

47,
0,

48,
0,

14,
48,
0,

48,
0,

48,
0,

48,
0,

33,
48,
0,

48,
0,

48,
0,

45,
48,
0,

45,
48,
0,

45,
48,
0,

48,
0,

24,
48,
0,

26,
48,
0,

34,
48,
0,

48,
0,

48,
0,

48,
0,

47,
0,

48,
0,

48,
0,

35,
48,
0,

45,
48,
0,

28,
48,
0,

29,
48,
0,

47,
0,

46,
0,

46,
0,
0};
# define YYTYPE unsigned char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
{0,0},	{0,0},	{1,3},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{1,4},	{1,5},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{1,6},	{0,0},	
{55,0},	{55,0},	{0,0},	{1,7},	
{0,0},	{1,8},	{1,8},	{1,9},	
{0,0},	{0,0},	{1,8},	{1,10},	
{7,40},	{1,11},	{1,12},	{1,12},	
{1,12},	{1,12},	{1,12},	{1,12},	
{1,12},	{1,12},	{1,12},	{55,0},	
{55,0},	{1,13},	{1,14},	{1,15},	
{0,0},	{0,0},	{1,16},	{55,0},	
{55,0},	{2,8},	{2,8},	{6,39},	
{1,17},	{13,48},	{13,49},	{14,50},	
{15,51},	{15,52},	{2,12},	{2,12},	
{2,12},	{2,12},	{2,12},	{2,12},	
{2,12},	{2,12},	{2,12},	{45,44},	
{0,0},	{2,13},	{2,14},	{2,15},	
{1,8},	{1,18},	{1,8},	{0,0},	
{1,10},	{0,0},	{1,19},	{1,20},	
{0,0},	{1,21},	{1,22},	{1,23},	
{1,24},	{1,25},	{1,26},	{24,65},	
{32,85},	{1,27},	{1,28},	{1,29},	
{1,30},	{1,31},	{34,89},	{1,32},	
{1,33},	{1,34},	{1,35},	{35,90},	
{2,8},	{2,18},	{2,8},	{12,46},	
{24,66},	{1,36},	{2,19},	{2,20},	
{25,67},	{2,21},	{2,22},	{2,23},	
{2,24},	{2,25},	{2,26},	{56,98},	
{57,99},	{2,27},	{2,28},	{2,29},	
{2,30},	{2,31},	{3,37},	{2,32},	
{2,33},	{2,34},	{2,35},	{29,78},	
{26,68},	{28,75},	{3,0},	{3,0},	
{26,69},	{2,36},	{27,72},	{12,46},	
{36,91},	{29,79},	{27,73},	{26,70},	
{58,100},	{26,71},	{27,74},	{28,76},	
{30,80},	{31,82},	{31,83},	{30,81},	
{31,84},	{28,77},	{59,101},	{60,102},	
{62,104},	{3,0},	{3,0},	{63,105},	
{65,107},	{66,108},	{67,109},	{3,0},	
{68,110},	{3,0},	{3,0},	{3,37},	
{70,113},	{72,114},	{3,0},	{3,0},	
{74,117},	{3,0},	{3,0},	{3,0},	
{3,0},	{3,0},	{3,0},	{3,0},	
{3,0},	{3,0},	{3,0},	{69,111},	
{73,115},	{3,0},	{3,0},	{3,0},	
{69,112},	{73,116},	{3,0},	{3,0},	
{3,0},	{3,0},	{3,0},	{3,0},	
{3,0},	{3,0},	{3,0},	{3,0},	
{3,0},	{3,0},	{3,0},	{3,0},	
{3,0},	{3,0},	{3,0},	{3,0},	
{3,0},	{3,0},	{3,0},	{3,0},	
{3,0},	{3,0},	{3,0},	{3,0},	
{3,0},	{61,44},	{3,0},	{64,44},	
{3,0},	{75,118},	{3,0},	{3,0},	
{3,0},	{3,0},	{3,0},	{3,0},	
{3,0},	{3,0},	{3,38},	{3,0},	
{3,0},	{3,0},	{3,0},	{3,0},	
{3,0},	{3,0},	{3,0},	{3,0},	
{3,0},	{3,0},	{3,0},	{3,0},	
{3,0},	{3,0},	{3,0},	{3,0},	
{33,86},	{3,0},	{9,0},	{9,0},	
{76,119},	{77,120},	{78,121},	{79,122},	
{81,123},	{33,87},	{61,103},	{82,124},	
{83,125},	{64,106},	{84,126},	{33,88},	
{85,127},	{86,128},	{87,129},	{88,130},	
{89,131},	{90,132},	{100,138},	{101,139},	
{102,140},	{9,0},	{9,0},	{103,141},	
{105,142},	{106,143},	{107,144},	{9,0},	
{108,145},	{9,0},	{9,0},	{109,146},	
{110,147},	{111,148},	{9,0},	{9,0},	
{112,149},	{9,0},	{9,0},	{9,0},	
{9,0},	{9,0},	{9,0},	{9,0},	
{9,0},	{9,0},	{9,0},	{113,150},	
{115,151},	{9,0},	{9,0},	{9,0},	
{116,152},	{117,125},	{9,0},	{9,0},	
{9,0},	{9,0},	{9,0},	{9,0},	
{9,0},	{9,0},	{9,0},	{9,0},	
{9,0},	{9,0},	{9,0},	{9,0},	
{9,0},	{9,0},	{9,0},	{9,0},	
{9,0},	{9,0},	{9,0},	{9,0},	
{9,0},	{9,0},	{9,0},	{9,0},	
{9,0},	{118,153},	{9,0},	{120,156},	
{9,0},	{123,157},	{9,0},	{9,0},	
{9,0},	{9,0},	{9,0},	{9,0},	
{9,0},	{9,0},	{9,38},	{9,0},	
{9,0},	{9,0},	{9,0},	{9,0},	
{9,0},	{9,0},	{9,0},	{9,0},	
{9,0},	{9,0},	{9,0},	{9,0},	
{9,0},	{9,0},	{9,0},	{9,0},	
{124,158},	{9,0},	{11,41},	{11,42},	
{119,154},	{11,43},	{11,43},	{11,43},	
{11,43},	{11,43},	{11,43},	{11,43},	
{11,43},	{11,43},	{11,43},	{11,44},	
{126,159},	{127,160},	{119,155},	{129,125},	
{135,136},	{138,167},	{11,45},	{11,45},	
{11,45},	{11,45},	{11,45},	{11,45},	
{11,46},	{11,46},	{11,46},	{11,46},	
{11,46},	{11,46},	{11,46},	{11,46},	
{11,46},	{11,46},	{11,46},	{11,46},	
{11,46},	{11,46},	{11,46},	{11,46},	
{11,46},	{11,47},	{11,46},	{11,46},	
{139,168},	{141,169},	{142,125},	{144,170},	
{11,41},	{145,171},	{11,45},	{11,45},	
{11,45},	{11,45},	{11,45},	{11,45},	
{11,46},	{11,46},	{11,46},	{11,46},	
{11,46},	{11,46},	{11,46},	{11,46},	
{11,46},	{11,46},	{11,46},	{11,46},	
{11,46},	{11,46},	{11,46},	{11,46},	
{11,46},	{11,47},	{11,46},	{11,46},	
{16,46},	{150,172},	{16,45},	{16,45},	
{16,45},	{16,45},	{16,45},	{16,45},	
{16,45},	{16,45},	{16,45},	{16,45},	
{42,92},	{42,93},	{42,93},	{42,93},	
{42,93},	{42,93},	{42,93},	{42,93},	
{42,93},	{42,93},	{151,173},	{17,41},	
{17,46},	{154,174},	{17,46},	{17,46},	
{17,46},	{17,46},	{17,46},	{17,46},	
{17,46},	{17,46},	{17,46},	{17,46},	
{155,175},	{156,176},	{157,177},	{159,178},	
{166,165},	{168,183},	{16,46},	{17,46},	
{17,46},	{17,46},	{17,46},	{17,46},	
{17,46},	{17,46},	{17,46},	{17,46},	
{17,46},	{17,46},	{17,46},	{17,46},	
{17,46},	{17,46},	{17,46},	{17,46},	
{17,46},	{17,46},	{17,46},	{17,46},	
{17,46},	{17,46},	{17,46},	{17,46},	
{17,46},	{169,184},	{170,185},	{171,186},	
{172,187},	{17,41},	{16,46},	{17,46},	
{17,46},	{17,46},	{17,46},	{17,46},	
{17,46},	{17,46},	{17,46},	{17,46},	
{17,46},	{17,46},	{17,46},	{17,46},	
{17,46},	{17,46},	{17,46},	{17,46},	
{17,46},	{17,46},	{17,46},	{17,46},	
{17,46},	{17,46},	{17,46},	{17,46},	
{17,46},	{18,53},	{173,188},	{53,0},	
{53,0},	{176,189},	{177,190},	{181,182},	
{183,195},	{18,0},	{18,0},	{19,46},	
{185,196},	{19,45},	{19,45},	{19,45},	
{19,45},	{19,45},	{19,45},	{19,45},	
{19,45},	{19,45},	{19,45},	{186,197},	
{187,198},	{189,199},	{53,0},	{53,0},	
{190,200},	{195,204},	{199,205},	{200,206},	
{18,0},	{18,0},	{53,0},	{53,0},	
{202,203},	{204,209},	{18,54},	{205,210},	
{18,0},	{18,0},	{18,53},	{211,212},	
{0,0},	{18,54},	{18,54},	{0,0},	
{18,54},	{0,0},	{0,0},	{0,0},	
{20,46},	{19,46},	{20,45},	{20,45},	
{20,45},	{20,45},	{20,45},	{20,45},	
{20,45},	{20,45},	{20,45},	{20,45},	
{0,0},	{18,54},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{18,54},	
{0,0},	{0,0},	{0,0},	{19,56},	
{0,0},	{0,0},	{0,0},	{19,57},	
{0,0},	{19,58},	{0,0},	{0,0},	
{0,0},	{19,46},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{20,46},	{18,54},	
{0,0},	{0,0},	{0,0},	{53,55},	
{0,0},	{0,0},	{0,0},	{0,0},	
{21,46},	{18,55},	{21,45},	{21,45},	
{21,45},	{21,45},	{21,45},	{21,45},	
{21,45},	{21,45},	{21,45},	{21,45},	
{0,0},	{0,0},	{0,0},	{0,0},	
{20,59},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{20,46},	{20,60},	
{22,46},	{0,0},	{22,45},	{22,45},	
{22,45},	{22,45},	{22,45},	{22,45},	
{22,45},	{22,45},	{22,45},	{22,45},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{23,46},	{21,46},	{23,45},	
{23,45},	{23,45},	{23,45},	{23,45},	
{23,45},	{23,45},	{23,45},	{23,45},	
{23,45},	{0,0},	{93,133},	{21,61},	
{93,93},	{93,93},	{93,93},	{93,93},	
{93,93},	{93,93},	{93,93},	{93,93},	
{93,93},	{93,93},	{22,46},	{0,0},	
{0,0},	{21,62},	{0,0},	{0,0},	
{0,0},	{0,0},	{21,46},	{0,0},	
{0,0},	{37,0},	{37,0},	{0,0},	
{0,0},	{0,0},	{94,42},	{23,46},	
{94,94},	{94,94},	{94,94},	{94,94},	
{94,94},	{94,94},	{94,94},	{94,94},	
{94,94},	{94,94},	{22,63},	{23,64},	
{0,0},	{0,0},	{22,46},	{0,0},	
{37,0},	{37,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{37,0},	{0,0},	
{37,0},	{37,0},	{0,0},	{0,0},	
{0,0},	{37,0},	{37,0},	{23,46},	
{37,0},	{37,0},	{37,0},	{37,0},	
{37,0},	{37,0},	{37,0},	{37,0},	
{37,0},	{37,0},	{0,0},	{0,0},	
{37,0},	{37,0},	{37,0},	{0,0},	
{0,0},	{37,0},	{37,0},	{37,0},	
{37,0},	{37,0},	{37,0},	{37,0},	
{37,0},	{37,0},	{37,0},	{37,0},	
{37,0},	{37,0},	{37,0},	{37,0},	
{37,0},	{37,0},	{37,0},	{37,0},	
{37,0},	{37,0},	{37,0},	{37,0},	
{37,0},	{37,0},	{37,0},	{37,0},	
{0,0},	{37,0},	{0,0},	{37,0},	
{0,0},	{37,0},	{37,0},	{37,0},	
{37,0},	{37,0},	{37,0},	{37,0},	
{37,0},	{37,38},	{37,0},	{37,0},	
{37,0},	{37,0},	{37,0},	{37,0},	
{37,0},	{37,0},	{37,0},	{37,0},	
{37,0},	{37,0},	{37,0},	{37,0},	
{37,0},	{37,0},	{37,0},	{43,42},	
{37,0},	{43,94},	{43,94},	{43,94},	
{43,94},	{43,94},	{43,94},	{43,94},	
{43,94},	{43,94},	{43,94},	{43,44},	
{44,95},	{44,95},	{44,95},	{44,95},	
{44,95},	{44,95},	{44,95},	{44,95},	
{44,95},	{44,95},	{44,96},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{44,95},	{44,95},	{44,95},	
{44,95},	{44,95},	{44,95},	{47,97},	
{47,97},	{47,97},	{47,97},	{47,97},	
{47,97},	{47,97},	{47,97},	{47,97},	
{47,97},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{47,97},	{47,97},	{47,97},	{47,97},	
{47,97},	{47,97},	{0,0},	{54,54},	
{0,0},	{44,95},	{44,95},	{44,95},	
{44,95},	{44,95},	{44,95},	{54,0},	
{54,0},	{92,133},	{0,0},	{92,93},	
{92,93},	{92,93},	{92,93},	{92,93},	
{92,93},	{92,93},	{92,93},	{92,93},	
{92,93},	{0,0},	{0,0},	{0,0},	
{47,97},	{47,97},	{47,97},	{47,97},	
{47,97},	{47,97},	{54,0},	{54,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{54,54},	{0,0},	{54,0},	{54,0},	
{54,54},	{0,0},	{0,0},	{54,54},	
{54,54},	{0,0},	{54,54},	{0,0},	
{0,0},	{0,0},	{0,0},	{92,134},	
{133,161},	{133,162},	{133,162},	{133,162},	
{133,162},	{133,162},	{133,162},	{133,162},	
{133,162},	{133,162},	{0,0},	{54,54},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{54,54},	{95,135},	{95,135},	
{95,135},	{95,135},	{95,135},	{95,135},	
{95,135},	{95,135},	{95,135},	{95,135},	
{95,136},	{0,0},	{0,0},	{92,134},	
{0,0},	{0,0},	{0,0},	{95,135},	
{95,135},	{95,135},	{95,135},	{95,135},	
{95,135},	{54,54},	{96,137},	{96,137},	
{96,137},	{96,137},	{96,137},	{96,137},	
{96,137},	{96,137},	{96,137},	{96,137},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{96,137},	
{96,137},	{96,137},	{96,137},	{96,137},	
{96,137},	{0,0},	{0,0},	{95,135},	
{95,135},	{95,135},	{95,135},	{95,135},	
{95,135},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{97,42},	{0,0},	
{97,97},	{97,97},	{97,97},	{97,97},	
{97,97},	{97,97},	{97,97},	{97,97},	
{97,97},	{97,97},	{0,0},	{96,137},	
{96,137},	{96,137},	{96,137},	{96,137},	
{96,137},	{97,97},	{97,97},	{97,97},	
{97,97},	{97,97},	{97,97},	{134,163},	
{134,163},	{134,163},	{134,163},	{134,163},	
{134,163},	{134,163},	{134,163},	{134,163},	
{134,163},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{134,163},	{134,163},	{134,163},	{134,163},	
{134,163},	{134,163},	{0,0},	{0,0},	
{0,0},	{97,97},	{97,97},	{97,97},	
{97,97},	{97,97},	{97,97},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{136,164},	{136,164},	{136,164},	
{136,164},	{136,164},	{136,164},	{136,164},	
{136,164},	{136,164},	{136,164},	{136,165},	
{134,163},	{134,163},	{134,163},	{134,163},	
{134,163},	{134,163},	{136,164},	{136,164},	
{136,164},	{136,164},	{136,164},	{136,164},	
{137,166},	{137,166},	{137,166},	{137,166},	
{137,166},	{137,166},	{137,166},	{137,166},	
{137,166},	{137,166},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{137,166},	{137,166},	{137,166},	
{137,166},	{137,166},	{137,166},	{0,0},	
{0,0},	{0,0},	{136,164},	{136,164},	
{136,164},	{136,164},	{136,164},	{136,164},	
{161,179},	{0,0},	{161,162},	{161,162},	
{161,162},	{161,162},	{161,162},	{161,162},	
{161,162},	{161,162},	{161,162},	{161,162},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{137,166},	{137,166},	{137,166},	
{137,166},	{137,166},	{137,166},	{162,179},	
{0,0},	{162,162},	{162,162},	{162,162},	
{162,162},	{162,162},	{162,162},	{162,162},	
{162,162},	{162,162},	{162,162},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{163,133},	{161,180},	{163,163},	
{163,163},	{163,163},	{163,163},	{163,163},	
{163,163},	{163,163},	{163,163},	{163,163},	
{163,163},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{163,163},	{163,163},	{163,163},	{163,163},	
{163,163},	{163,163},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{161,180},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{164,181},	{164,181},	{164,181},	
{164,181},	{164,181},	{164,181},	{164,181},	
{164,181},	{164,181},	{164,181},	{164,182},	
{163,163},	{163,163},	{163,163},	{163,163},	
{163,163},	{163,163},	{164,181},	{164,181},	
{164,181},	{164,181},	{164,181},	{164,181},	
{165,137},	{165,137},	{165,137},	{165,137},	
{165,137},	{165,137},	{165,137},	{165,137},	
{165,137},	{165,137},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{165,137},	{165,137},	{165,137},	
{165,137},	{165,137},	{165,137},	{0,0},	
{0,0},	{0,0},	{164,181},	{164,181},	
{164,181},	{164,181},	{164,181},	{164,181},	
{179,191},	{179,192},	{179,192},	{179,192},	
{179,192},	{179,192},	{179,192},	{179,192},	
{179,192},	{179,192},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{165,137},	{165,137},	{165,137},	
{165,137},	{165,137},	{165,137},	{180,193},	
{180,193},	{180,193},	{180,193},	{180,193},	
{180,193},	{180,193},	{180,193},	{180,193},	
{180,193},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{180,193},	{180,193},	{180,193},	{180,193},	
{180,193},	{180,193},	{182,194},	{182,194},	
{182,194},	{182,194},	{182,194},	{182,194},	
{182,194},	{182,194},	{182,194},	{182,194},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{182,194},	
{182,194},	{182,194},	{182,194},	{182,194},	
{182,194},	{0,0},	{0,0},	{0,0},	
{180,193},	{180,193},	{180,193},	{180,193},	
{180,193},	{180,193},	{191,192},	{191,192},	
{191,192},	{191,192},	{191,192},	{191,192},	
{191,192},	{191,192},	{191,192},	{191,192},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{182,194},	
{182,194},	{182,194},	{182,194},	{182,194},	
{182,194},	{192,192},	{192,192},	{192,192},	
{192,192},	{192,192},	{192,192},	{192,192},	
{192,192},	{192,192},	{192,192},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{193,179},	{191,201},	{193,193},	
{193,193},	{193,193},	{193,193},	{193,193},	
{193,193},	{193,193},	{193,193},	{193,193},	
{193,193},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{193,193},	{193,193},	{193,193},	{193,193},	
{193,193},	{193,193},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{191,201},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{194,202},	{194,202},	{194,202},	
{194,202},	{194,202},	{194,202},	{194,202},	
{194,202},	{194,202},	{194,202},	{194,203},	
{193,193},	{193,193},	{193,193},	{193,193},	
{193,193},	{193,193},	{194,202},	{194,202},	
{194,202},	{194,202},	{194,202},	{194,202},	
{201,207},	{201,207},	{201,207},	{201,207},	
{201,207},	{201,207},	{201,207},	{201,207},	
{201,207},	{201,207},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{201,207},	{201,207},	{201,207},	
{201,207},	{201,207},	{201,207},	{0,0},	
{0,0},	{0,0},	{194,202},	{194,202},	
{194,202},	{194,202},	{194,202},	{194,202},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{203,208},	{203,208},	
{203,208},	{203,208},	{203,208},	{203,208},	
{203,208},	{203,208},	{203,208},	{203,208},	
{0,0},	{201,207},	{201,207},	{201,207},	
{201,207},	{201,207},	{201,207},	{203,208},	
{203,208},	{203,208},	{203,208},	{203,208},	
{203,208},	{207,207},	{207,207},	{207,207},	
{207,207},	{207,207},	{207,207},	{207,207},	
{207,207},	{207,207},	{207,207},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{207,207},	{207,207},	
{207,207},	{207,207},	{207,207},	{207,207},	
{0,0},	{0,0},	{0,0},	{203,208},	
{203,208},	{203,208},	{203,208},	{203,208},	
{203,208},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{208,211},	
{208,211},	{208,211},	{208,211},	{208,211},	
{208,211},	{208,211},	{208,211},	{208,211},	
{208,211},	{208,212},	{207,207},	{207,207},	
{207,207},	{207,207},	{207,207},	{207,207},	
{208,211},	{208,211},	{208,211},	{208,211},	
{208,211},	{208,211},	{212,213},	{212,213},	
{212,213},	{212,213},	{212,213},	{212,213},	
{212,213},	{212,213},	{212,213},	{212,213},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{212,213},	
{212,213},	{212,213},	{212,213},	{212,213},	
{212,213},	{0,0},	{0,0},	{0,0},	
{208,211},	{208,211},	{208,211},	{208,211},	
{208,211},	{208,211},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{213,214},	{213,214},	{213,214},	{213,214},	
{213,214},	{213,214},	{213,214},	{213,214},	
{213,214},	{213,214},	{0,0},	{212,213},	
{212,213},	{212,213},	{212,213},	{212,213},	
{212,213},	{213,214},	{213,214},	{213,214},	
{213,214},	{213,214},	{213,214},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{213,214},	{213,214},	{213,214},	
{213,214},	{213,214},	{213,214},	{0,0},	
{0,0}};
struct yysvf yysvec[] = {
{0,	0,	0},
{-1,	0,		0},	
{-29,	yysvec+1,	0},	
{-141,	0,		yyvstop+1},
{0,	0,		yyvstop+3},
{0,	0,		yyvstop+6},
{10,	0,		yyvstop+8},
{10,	0,		yyvstop+11},
{0,	0,		yyvstop+14},
{-257,	yysvec+3,	yyvstop+17},
{0,	0,		yyvstop+20},
{337,	0,		yyvstop+22},
{35,	yysvec+11,	yyvstop+25},
{13,	0,		yyvstop+28},
{14,	0,		yyvstop+31},
{15,	0,		yyvstop+34},
{414,	yysvec+11,	yyvstop+37},
{438,	0,		yyvstop+39},
{-560,	0,		yyvstop+41},
{525,	yysvec+11,	yyvstop+43},
{566,	yysvec+11,	yyvstop+45},
{618,	yysvec+11,	yyvstop+47},
{642,	yysvec+11,	yyvstop+49},
{659,	yysvec+11,	yyvstop+51},
{10,	yysvec+17,	yyvstop+53},
{17,	yysvec+17,	yyvstop+55},
{49,	yysvec+17,	yyvstop+57},
{57,	yysvec+17,	yyvstop+59},
{52,	yysvec+17,	yyvstop+61},
{46,	yysvec+17,	yyvstop+63},
{50,	yysvec+17,	yyvstop+65},
{54,	yysvec+17,	yyvstop+67},
{11,	yysvec+17,	yyvstop+69},
{165,	yysvec+17,	yyvstop+71},
{15,	yysvec+17,	yyvstop+73},
{19,	yysvec+17,	yyvstop+75},
{32,	0,		yyvstop+77},
{-732,	yysvec+3,	0},	
{0,	0,		yyvstop+80},
{0,	0,		yyvstop+82},
{0,	0,		yyvstop+84},
{0,	yysvec+17,	0},	
{424,	yysvec+17,	yyvstop+86},
{809,	yysvec+17,	yyvstop+88},
{820,	0,		0},	
{29,	yysvec+17,	yyvstop+91},
{0,	yysvec+17,	yyvstop+93},
{843,	yysvec+17,	yyvstop+95},
{0,	0,		yyvstop+97},
{0,	0,		yyvstop+99},
{0,	0,		yyvstop+101},
{0,	0,		yyvstop+103},
{0,	0,		yyvstop+105},
{-554,	yysvec+18,	yyvstop+107},
{-914,	0,		yyvstop+109},
{-27,	yysvec+54,	yyvstop+111},
{35,	yysvec+17,	yyvstop+114},
{24,	yysvec+17,	yyvstop+116},
{63,	yysvec+17,	yyvstop+118},
{59,	yysvec+17,	yyvstop+120},
{55,	yysvec+17,	yyvstop+122},
{175,	yysvec+17,	yyvstop+124},
{56,	yysvec+17,	yyvstop+126},
{71,	yysvec+17,	yyvstop+128},
{177,	yysvec+17,	yyvstop+130},
{60,	yysvec+17,	yyvstop+132},
{76,	yysvec+17,	yyvstop+134},
{63,	yysvec+17,	yyvstop+136},
{71,	yysvec+17,	yyvstop+138},
{90,	yysvec+17,	yyvstop+140},
{86,	yysvec+17,	yyvstop+142},
{0,	yysvec+17,	yyvstop+144},
{69,	yysvec+17,	yyvstop+147},
{90,	yysvec+17,	yyvstop+149},
{78,	yysvec+17,	yyvstop+151},
{122,	yysvec+17,	yyvstop+153},
{156,	yysvec+17,	yyvstop+155},
{161,	yysvec+17,	yyvstop+157},
{154,	yysvec+17,	yyvstop+159},
{155,	yysvec+17,	yyvstop+161},
{0,	yysvec+17,	yyvstop+163},
{156,	yysvec+17,	yyvstop+166},
{161,	yysvec+17,	yyvstop+168},
{164,	yysvec+17,	yyvstop+170},
{167,	yysvec+17,	yyvstop+172},
{166,	yysvec+17,	yyvstop+174},
{184,	yysvec+17,	yyvstop+176},
{177,	yysvec+17,	yyvstop+178},
{184,	yysvec+17,	yyvstop+180},
{172,	yysvec+17,	yyvstop+182},
{173,	yysvec+17,	yyvstop+184},
{0,	0,		yyvstop+186},
{879,	yysvec+17,	yyvstop+188},
{672,	yysvec+17,	yyvstop+191},
{700,	yysvec+17,	yyvstop+194},
{938,	0,		0},	
{962,	yysvec+44,	0},	
{1000,	yysvec+17,	yyvstop+197},
{0,	yysvec+17,	yyvstop+200},
{0,	yysvec+17,	yyvstop+203},
{178,	yysvec+17,	yyvstop+206},
{190,	yysvec+17,	yyvstop+208},
{187,	yysvec+17,	yyvstop+210},
{181,	yysvec+17,	yyvstop+212},
{0,	yysvec+17,	yyvstop+214},
{191,	yysvec+17,	yyvstop+217},
{188,	yysvec+17,	yyvstop+219},
{193,	yysvec+17,	yyvstop+221},
{199,	yysvec+17,	yyvstop+223},
{183,	yysvec+17,	yyvstop+225},
{188,	yysvec+17,	yyvstop+227},
{189,	yysvec+17,	yyvstop+229},
{192,	yysvec+17,	yyvstop+231},
{204,	yysvec+17,	yyvstop+233},
{0,	yysvec+17,	yyvstop+235},
{213,	yysvec+17,	yyvstop+238},
{205,	yysvec+17,	yyvstop+241},
{214,	yysvec+17,	yyvstop+243},
{242,	yysvec+17,	yyvstop+245},
{284,	yysvec+17,	yyvstop+247},
{235,	yysvec+17,	yyvstop+249},
{0,	yysvec+17,	yyvstop+251},
{0,	yysvec+17,	yyvstop+254},
{255,	yysvec+17,	yyvstop+257},
{264,	yysvec+17,	yyvstop+259},
{0,	yysvec+17,	yyvstop+261},
{280,	yysvec+17,	yyvstop+264},
{285,	yysvec+17,	yyvstop+266},
{0,	yysvec+17,	yyvstop+268},
{287,	yysvec+17,	yyvstop+271},
{0,	yysvec+17,	yyvstop+273},
{0,	yysvec+17,	yyvstop+276},
{0,	yysvec+17,	yyvstop+279},
{920,	yysvec+17,	yyvstop+282},
{1023,	yysvec+17,	yyvstop+284},
{342,	0,		0},	
{1061,	0,		yyvstop+286},
{1084,	yysvec+136,	0},	
{294,	yysvec+17,	yyvstop+288},
{328,	yysvec+17,	yyvstop+290},
{0,	yysvec+17,	yyvstop+292},
{328,	yysvec+17,	yyvstop+295},
{316,	yysvec+17,	yyvstop+297},
{0,	yysvec+17,	yyvstop+299},
{312,	yysvec+17,	yyvstop+302},
{317,	yysvec+17,	yyvstop+304},
{0,	yysvec+17,	yyvstop+306},
{0,	yysvec+17,	yyvstop+309},
{0,	yysvec+17,	yyvstop+312},
{0,	yysvec+17,	yyvstop+315},
{344,	yysvec+17,	yyvstop+318},
{366,	yysvec+17,	yyvstop+320},
{0,	yysvec+17,	yyvstop+322},
{0,	yysvec+17,	yyvstop+325},
{377,	yysvec+17,	yyvstop+328},
{397,	yysvec+17,	yyvstop+330},
{392,	yysvec+17,	yyvstop+332},
{387,	yysvec+17,	yyvstop+334},
{0,	yysvec+17,	yyvstop+336},
{388,	yysvec+17,	yyvstop+339},
{0,	yysvec+17,	yyvstop+341},
{1118,	yysvec+17,	yyvstop+344},
{1141,	yysvec+17,	yyvstop+347},
{1159,	yysvec+17,	yyvstop+350},
{1197,	0,		0},	
{1220,	yysvec+136,	yyvstop+353},
{442,	0,		0},	
{0,	yysvec+17,	yyvstop+355},
{402,	yysvec+17,	yyvstop+358},
{413,	yysvec+17,	yyvstop+360},
{433,	yysvec+17,	yyvstop+362},
{430,	yysvec+17,	yyvstop+364},
{422,	yysvec+17,	yyvstop+366},
{458,	yysvec+17,	yyvstop+368},
{0,	yysvec+17,	yyvstop+370},
{0,	yysvec+17,	yyvstop+373},
{466,	yysvec+17,	yyvstop+376},
{449,	yysvec+17,	yyvstop+378},
{0,	yysvec+17,	yyvstop+380},
{1252,	yysvec+17,	yyvstop+383},
{1275,	yysvec+17,	yyvstop+385},
{509,	0,		0},	
{1298,	yysvec+136,	yyvstop+387},
{471,	yysvec+17,	yyvstop+389},
{0,	yysvec+17,	yyvstop+391},
{451,	yysvec+17,	yyvstop+394},
{469,	yysvec+17,	yyvstop+396},
{484,	yysvec+17,	yyvstop+398},
{0,	yysvec+17,	yyvstop+400},
{488,	yysvec+17,	yyvstop+403},
{478,	yysvec+17,	yyvstop+405},
{1330,	yysvec+17,	yyvstop+407},
{1353,	yysvec+17,	yyvstop+410},
{1371,	yysvec+17,	yyvstop+413},
{1409,	0,		0},	
{474,	yysvec+17,	yyvstop+416},
{0,	yysvec+17,	yyvstop+418},
{0,	yysvec+17,	yyvstop+421},
{0,	yysvec+17,	yyvstop+424},
{475,	yysvec+17,	yyvstop+427},
{491,	yysvec+17,	yyvstop+429},
{1432,	yysvec+17,	yyvstop+431},
{538,	0,		0},	
{1470,	yysvec+136,	yyvstop+433},
{481,	yysvec+17,	yyvstop+435},
{483,	yysvec+17,	yyvstop+437},
{0,	yysvec+17,	yyvstop+439},
{1493,	yysvec+17,	yyvstop+442},
{1531,	0,		0},	
{0,	yysvec+17,	yyvstop+445},
{0,	yysvec+17,	yyvstop+448},
{545,	0,		0},	
{1554,	yysvec+136,	yyvstop+451},
{1592,	yysvec+136,	yyvstop+453},
{0,	yysvec+166,	yyvstop+455},
{0,	0,	0}};
struct yywork *yytop = yycrank+1694;
struct yysvf *yybgin = yysvec+1;
unsigned char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,'!' ,01  ,01  ,01  ,01  ,'&' ,01  ,
'!' ,'!' ,'*' ,'*' ,01  ,'-' ,'.' ,'*' ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,'*' ,01  ,'&' ,'&' ,'&' ,01  ,
01  ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'G' ,
'G' ,'G' ,'G' ,'G' ,'G' ,'G' ,'G' ,'G' ,
'G' ,'G' ,'G' ,'G' ,'G' ,'G' ,'G' ,'G' ,
'G' ,'G' ,'G' ,'&' ,01  ,'&' ,01  ,'_' ,
01  ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'G' ,
'G' ,'G' ,'G' ,'G' ,'G' ,'G' ,'G' ,'G' ,
'G' ,'G' ,'G' ,'G' ,'G' ,'G' ,'G' ,'G' ,
'G' ,'G' ,'G' ,01  ,'&' ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
0};
unsigned char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/* @(#) A.10.32.03 HP C LANGUAGE TOOL (NCFORM) 960517 $      */
int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
 
#ifdef YYNLS16_WCHAR
unsigned char yytextuc[YYLMAX * sizeof(wchar_t)];
# ifdef YY_PCT_POINT /* for %pointer */
wchar_t yytextarr[YYLMAX];
wchar_t *yytext;
# else               /* %array */
wchar_t yytextarr[1];
wchar_t yytext[YYLMAX];
# endif
#else
unsigned char yytextuc;
# ifdef YY_PCT_POINT /* for %pointer */
unsigned char yytextarr[YYLMAX];
unsigned char *yytext;
# else               /* %array */
unsigned char yytextarr[1];
# ifdef YYCHAR_ARRAY
char yytext[YYLMAX];
# else
unsigned char yytext[YYLMAX];
# endif
# endif
#endif

struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
unsigned char yysbuf[YYLMAX];
unsigned char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
/*	char *yylastch;
 * ***** nls8 ***** */
	unsigned char *yylastch, sec, third, fourth;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
#ifdef YYNLS16_WCHAR
		yylastch = yytextuc;
#else
# ifdef YYCHAR_ARRAY
		yylastch = (unsigned char *)yytext;
# else
		yylastch = yytext;
# endif
#endif
	else {
		yymorfg=0;
#ifdef YYNLS16_WCHAR
		yylastch = yytextuc+yylenguc;
#else
# ifdef YYCHAR_ARRAY
		yylastch = (unsigned char *)yytext+yyleng;
# else
		yylastch = yytext+yyleng;
# endif
#endif
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = &yycrank[yystate->yystoff];
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == 0)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt = &yycrank[yystate->yystoff]) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
#ifdef YYNLS16_WCHAR
				yylenguc = yylastch-yytextuc+1;
				yytextuc[yylenguc] = 0;
#else
# ifdef YYCHAR_ARRAY
				yyleng = yylastch-(unsigned char*)yytext+1;
# else
				yyleng = yylastch-yytext+1;
# endif
				yytext[yyleng] = 0;
#endif
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
#ifdef YYNLS16_WCHAR
					sprint(yytextuc);
#else
					sprint(yytext);
#endif
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
#ifdef YYNLS16_WCHAR
		if (yytextuc[0] == 0  /* && feof(yyin) */)
#else
		if (yytext[0] == 0  /* && feof(yyin) */)
#endif
			{
			yysptr=yysbuf;
			return(0);
			}
#ifdef YYNLS16_WCHAR
		yyprevious = yytextuc[0] = input();
#else
		yyprevious = yytext[0] = input();
#endif
		if (yyprevious>0) {
			output(yyprevious);
#ifdef YYNLS16
                        if (yynls16) {
			int noBytes;
                        sec = input();
                        third = input();
                        fourth = input();
#ifdef YYNLS16_WCHAR
                        noBytes = MultiByte(yytextuc[0],sec,third,fourth);
#else 
                        noBytes = MultiByte(yytext[0],sec,third,fourth);
#endif          
     					switch(noBytes) {
     					case 2:
#ifdef YYNLS16_WCHAR
 						output(yyprevious=yytextuc[0]=sec);
#else
 						output(yyprevious=yytext[0]=sec);
#endif
                                                 unput(fourth);
                                                 unput(third);
                                                 break;
     					case 3:
#ifdef YYNLS16_WCHAR
 						output(yyprevious=yytextuc[0]=sec);
 						output(yyprevious=yytextuc[0]=third);
#else
 						output(yyprevious=yytext[0]=sec);
 						output(yyprevious=yytext[0]=third);
#endif
                                                 unput(fourth);
                                                 break; 
                                         case 4:
#ifdef YYNLS16_WCHAR
 						output(yyprevious=yytextuc[0]=sec);
 						output(yyprevious=yytextuc[0]=third);
 						output(yyprevious=yytextuc[0]=fourth);
#else
 						output(yyprevious=yytext[0]=sec);
 						output(yyprevious=yytext[0]=third);
 						output(yyprevious=yytext[0]=fourth);
#endif
                                                 break;                                                                                            
					default:
					        unput(fourth);
					        unput(third);
						unput(sec);
						break;
						}
					}
#endif
                }
#ifdef YYNLS16_WCHAR
		yylastch=yytextuc;
#else
# ifdef YYCHAR_ARRAY
		yylastch=(unsigned char*)yytext;
# else
		yylastch=yytext;
# endif
#endif
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}

# ifdef __cplusplus
yyback(int *p, int m)
# else
yyback(p, m)
	int *p;
# endif
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	
	}

#if (defined(__cplusplus) || defined(__STDC__))
void yyoutput(int c)
#else
yyoutput(c)
  int c;
# endif
{
	output(c);
}

#if (defined(__cplusplus) || defined(__STDC__))
void yyunput(int c)
#else
yyunput(c)
   int c;
#endif
{
	unput(c);
}
